program testval

  use errorHandling
  use dal

  
  implicit none 

  integer :: nofrows,nofcols
  character(len=50) :: strAtt
  logical :: hascol


  type(DataSetT) :: specDataSet
  type(TableT) :: specTable

! Access output Spectral File

  specDataSet=dataSet("spec.pi",Read)
  specTable=table(specDataSet,"SPECTRUM")


! Output File has correct CONTENT keyword

  strAtt=stringAttribute(specDataSet,'CONTENT')
  if(trim(strAtt) /= "EPIC FLUCTUATIONS SPECTRUM") then
       call fatal('notFluctFile','Output file does not contain &
       &Fluctuations Product')
    endif


! Output File contains correct dimensions:
!     a)  Number of rows = 10 (one for each spectrum)

  nofrows=numberOfRows(specTable)
  if(nofrows /= 10) &
       call fatal('IncompOutput','Output file is Incomplete')

!     b)  Number of columns = 14 and correct names

  nofcols=numberOfColumns(specTable)
  if(nofcols /= 14)call fatal('IncompOutput','Output file is Incomplete')

  hascol=hasColumn(specTable,"SPEC_NUM")
  if(.NOT.hascol)call fatal('IncompOutput','SPEC_NUM column not found')

  hascol=hasColumn(specTable,"CHANNEL")
  if(.NOT.hascol)call fatal('IncompOutput','CHANNEL column not found')

  hascol=hasColumn(specTable,"COUNTS")
  if(.NOT.hascol)call fatal('IncompOutput','COUNTS column not found')

  hascol=hasColumn(specTable,"STAT_ERR")
  if(.NOT.hascol)call fatal('IncompOutput','STAT_ERR column not found')

  hascol=hasColumn(specTable,"QUALITY")
  if(.NOT.hascol)call fatal('IncompOutput','QUALITY column not found')

  hascol=hasColumn(specTable,"GROUPING")
  if(.NOT.hascol)call fatal('IncompOutput','GROUPING column not found')

  hascol=hasColumn(specTable,"ROWID")
  if(.NOT.hascol)call fatal('IncompOutput','ROWID column not found')

  hascol=hasColumn(specTable,"BACKFILE")
  if(.NOT.hascol)call fatal('IncompOutput','BACKFILE column not found')

  hascol=hasColumn(specTable,"BACKSCAL")
  if(.NOT.hascol)call fatal('IncompOutput','BACKSCAL column not found')

  hascol=hasColumn(specTable,"CORRFILE")
  if(.NOT.hascol)call fatal('IncompOutput','CORRFILE column not found')

  hascol=hasColumn(specTable,"CORRSCAL")
  if(.NOT.hascol)call fatal('IncompOutput','CORRSCALL column not found')

  hascol=hasColumn(specTable,"RESPFILE")
  if(.NOT.hascol)call fatal('IncompOutput','RESPFILE column not found')

  hascol=hasColumn(specTable,"ANCRFILE")
  if(.NOT.hascol)call fatal('IncompOutput','ANCRFILE column not found')

  hascol=hasColumn(specTable,"EXPOSURE")
  if(.NOT.hascol)call fatal('IncompOutput','EXPOSURE column not found')
  
end program testval

